/* Transform a TIT file from cxterm to CC-PY table format.
   Input: cmdline, Output: stdout. */

#if !defined(__LARGE__) && !defined (__COMPACT__) && !defined (__HUGE__)
  #error "This program should be compiled using large data models"
#endif

typedef unsigned char byte;

#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>

#define NbrOfCC		6768

static byte *py[NbrOfCC];

static int near getword(byte *s,byte *w);

void main(int argc, byte *argv[])
{
  register int i,l,len,code;
  long j;
  byte s[256],w[256],pyma[256];
  FILE *f_in;

  if (argc!=2) {
usage:
    fprintf(stderr,"Usage: tit2tab inputfile [>outputfile]\n");
    return;
  }

  if ((f_in=fopen(argv[1],"rt"))==NULL) goto usage;

  for (i=0; i<NbrOfCC; i++) py[i]=NULL;

  j=0;
  while (fgets(s,256,f_in)!=NULL) {
    fprintf(stderr,"%ld\r",++j);
    if (!s[0]) break;
    if (s[0]<'a' || s[0]>'z') continue;
    l=getword(s,pyma);
    if (!l) continue;
    len=strlen(pyma)+1;
    do {
      l+=(i=getword(s+l,w));
      if (!i) break;
      if (strlen(w)==2) {
        code=(w[0]-161)*94+(w[1]-161);
        if (code>=1410 && code<NbrOfCC+1410) {
          code-=1410;
          if (py[code]==NULL) {
            if ((py[code]=malloc(len))==NULL) {
	mem_err:
	      fprintf(stderr,"Memory overflow!\n");
	      fclose(f_in); return;
            }
            strcpy(py[code],pyma);
          } else {
            if ((py[code]=realloc(py[code],strlen(py[code])+1+len))==NULL)
              goto mem_err;
            strcat(py[code]," ");
            strcat(py[code],pyma);
          }
        }
      }
    } while (1);
  }
  fclose(f_in);

  /* output new table */
  for (i=0; i<NbrOfCC; i++) {
    printf("%c%c ", i/94+15+161, i%94+161);
    if (py[i]==NULL) printf("\n"); else {
      printf("%s",py[i]);
      if (strchr(py[i],' ')!=NULL) printf(" *\n",py[i]); else putchar('\n');
    }
  }

  return;
}

int getword(byte *s,byte *w)
/* get next word from string s. returns length of the word plus
   leading blanks. */
{
  register int i;

  for (i=0; isspace(s[i]); i++);
  if (!s[i]) return 0;
  if (!sscanf(s+i,"%s",w)) w[0]='\0';
  return w[0] ? i+strlen(w):0;
}